
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.OrderBy;

@Entity
public class Department {
  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  private int id;

  private String name;

  @OneToMany(mappedBy = "department")
  @OrderBy("name ASC")
  private List<Professor> employees;

  public Department() {
    employees = new ArrayList<Professor>();
  }

  public int getId() {
    return id;
  }

  public void setId(int id) {
    this.id = id;
  }

  public String getName() {
    return name;
  }

  public void setName(String deptName) {
    this.name = deptName;
  }

  public void addProfessor(Professor employee) {
    if (!getProfessors().contains(employee)) {
      getProfessors().add(employee);
      if (employee.getDepartment() != null) {
        employee.getDepartment().getProfessors().remove(employee);
      }
      employee.setDepartment(this);
    }
  }

  public Collection<Professor> getProfessors() {
    return employees;
  }

  public String toString() {
    return "Department id: " + getId() + ", name: " + getName();
  }
}
